constant START = time()

--Hi
--In order to comply with competition rules, I have placed this below the very 1st line
--Just to say, I doubt this will win, but I have now learnt what a hash table is!
--I copied most of hash.ex from the demos and modified it to my needs.
--I hope its a bit faster the the hour or so the last entry took :-)
--Finally, to Derek, thankyou for all the hard work you have put into the competition
--and all the hard (and probably sometimes frustrating) work you have put into the win32lib
--project over the years, and wish you all the best for the future. Its a shame, because
--euphoria is losing some of its demi gods (!)
--Chris
--PS - please don't go?

--with trace
--with profile
without warning

include get.e
include wildcard.e

constant VCHARS = "ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789-"
sequence FrequencyTable, MFT
    FrequencyTable = repeat(0,20)

sequence inpfile, fname, chunk, words, strng, splt_strng, temp, token_table,
	most_frequent_tokens, token_freq_table,
    token_list
integer fp,fq, mflag, cur_char, first_char, splt_strng_count, pass
    inpfile = {}
    words = {}
    temp = {}
    token_table={}
integer word_count, token_match, UniqueTokenTally, displayXtokens

fname = command_line()
fname = fname[3]
pass = 0
token_match = 0


--load the file
fp = open(fname, "r")
    if fp = -1 then
        puts(1,"Can't find " & fname)
        abort(0)
    end if

    while(1) do
        chunk = get_bytes(fp, 100)
        inpfile &= chunk        
        if length(chunk) < 100 then
            exit
        end if
    end while
close(fp)

--The Hash table functions
--no credit here whatsover
--copied directly from standard RDS demo hash.ex
constant STRING = 1, COUNT = 2 -- fields for one hash table entry
constant HASH_BUCKETS = 1009  -- prime
-- Initialize the hash table to a sequence of empty "buckets"
sequence hash_table
hash_table = repeat({}, HASH_BUCKETS)
integer compares
compares = 0
integer numZeroBucket, max, items, len, stats, total_words
    total_words = 0

----------------------------------------------------------------------------------------------------------------------------
function hash_function(sequence string)
----------------------------------------------------------------------------------------------------------------------------
-- This function works well for English words.
-- It's fast to calculate and it gives a pretty even distribution.
-- These are the two properties that you want in a hash function.
    integer len
    atom val
    
    len = length(string)
    val = string[len] * 2 + len
    if len > 4 then
	len = 4
    end if
    for i = 1 to len - 1 do
	val = val * 64 + string[i]  -- shift 6 bits and add
    end for
    return remainder(val, HASH_BUCKETS) + 1
end function

----------------------------------------------------------------------------------------------------------------------------
procedure hash_add(sequence string)
----------------------------------------------------------------------------------------------------------------------------
-- If string is not in the table already, add it, with a count of 1, 
-- otherwise just increment its count.
    integer hash_val, found
    sequence bucket
    
    -- which bucket to search?
    hash_val = hash_function(string) 
    bucket = hash_table[hash_val]
    found = 0
    -- search this bucket for the string
    for i = 1 to length(bucket) do
	compares += 1
	if equal(string, bucket[i][STRING]) then
	    -- found it
	    found = i
	    exit
	end if
    end for
    if found then
	-- increment count
	bucket[found][COUNT] += 1
    else
	-- add new string with count 1:
	bucket = append(bucket, {string, 1})
    end if
    hash_table[hash_val] = bucket
end procedure

----------------------------------------------------------------------------------------------------------------------------
function valid_char(integer char)
----------------------------------------------------------------------------------------------------------------------------
for i = 1 to length(VCHARS) do
    if char = VCHARS[i] then return 1 end if
end for

return 0
end function


----------------------------------------------------------------------------------------------------------------------------
procedure append_token(sequence str)        --append str to token_list
----------------------------------------------------------------------------------------------------------------------------
if length(str) > 0 and length(str) < 21 then
    --token_list = append(token_list, str)
    hash_add(str)                       --add it to the hash table
    FrequencyTable[length(str)] += 1    --update the token length counters
    total_words += 1
end if
end procedure

----------------------------------------------------------------------------------------------------------------------------
function whitespace(integer char)
----------------------------------------------------------------------------------------------------------------------------
if char = ' ' or char = '\n' then return 1 end if
return 0
end function

----------------------------------------------------------------------------------------------------------------------------
function remove_quotes(sequence str) --and uppercase
----------------------------------------------------------------------------------------------------------------------------
sequence str2
str2 = {}
for i = 1 to length(str) do
    if str[i] != '\'' and str[i] != '\"' then
        str2 &= upper(str[i])
    end if
end for

return str2
end function

----------------------------------------------------------------------------------------------------------------------------
function remove_end_delimiters(sequence str) --and uppercase
----------------------------------------------------------------------------------------------------------------------------
sequence str2
integer len, cur_char, flag

len = length(str)
cur_char = 1
flag = 0
while cur_char <= len do
    for i = 1 to length(VCHARS) do
        if str[cur_char] = VCHARS[i] then
            flag = cur_char
            exit
        end if
    end for
    if flag > 0 then exit end if
    cur_char += 1
end while

if flag > 0 then
    str = str[flag..len]
else
    --no valid chars in string
    str2 = {}
    return str2
end if

len = length(str)
cur_char = len
flag = 0

while cur_char >= 1 do
    for i = 1 to length(VCHARS) do
        if str[cur_char] = VCHARS[i] then
            flag = cur_char
            exit
        end if
    end for
    if flag > 0 then exit end if
    cur_char -= 1
end while

if flag > 0 then
    str = str[1..flag]
else
    --no valid chars in string
    str2 = {}
    return str2
end if


return str
end function

----------------------------------------------------------------------------------------------------------------------------
function filter_string(sequence str)
----------------------------------------------------------------------------------------------------------------------------
sequence token
token = {}

token = remove_quotes(str)      --remove quotes and capialise

token = remove_end_delimiters(token)

return token
end function

----------------------------------------------------------------------------------------------------------------------------
function check_hyph(sequence str)
----------------------------------------------------------------------------------------------------------------------------
if length(str) > 0 then
    if str[1] = '-' or str[length(str)] = '-' then
        str = {}
    end if
end if

return str
end function

----------------------------------------------------------------------------------------------------------------------------
function check_alpha(sequence str)
----------------------------------------------------------------------------------------------------------------------------
if length(str) > 0 then
    for i = 1 to length(str) do
        if str[i] >= 'A' and str[i] <= 'Z' then
            return str
        end if
    end for
end if

str = {}

return str
end function


----------------------------------------------------------------------------------------------------------------------------
procedure split_append(sequence str)
----------------------------------------------------------------------------------------------------------------------------
sequence str2
integer cur_char, len, flag

str2 = {}
len = length(str)
cur_char = 1

while cur_char <= len do

    if valid_char(str[cur_char]) then
        str2 &= str[cur_char]
    else
        --check not preceeding or trailing'-'
        str2 = check_hyph(str2)
        --check does have at least one alpha character
        str2 = check_alpha(str2)
        append_token(str2)
        str2 = {}
    end if

    cur_char += 1
end while

str2 = check_hyph(str2)
str2 = check_alpha(str2)
append_token(str2)

end procedure




-----------------------------------[read file main loop create the clean word list]-----------------------------------------
cur_char = 1
strng = {}
token_list = {}
if length(inpfile) > 0 then
    while (cur_char) <= length(inpfile) do
        if whitespace(inpfile[cur_char]) then
            if length(strng) > 0 then
                --its a whitespace, send the strng off for filtering
                strng = filter_string(strng)
                --split and append token(s) to token_list
                split_append(strng)

                strng = {}
            end if
        else
            --add it to the current strng
            strng &= inpfile[cur_char]
        end if
        cur_char += 1
    end while
--finally
if length(strng) > 0 then                                
    strng = filter_string(strng)                         
    split_append(strng)                                  
end if                                                   

else --for zero length input files
    printf(1, "Chris Burch %s\n", {fname} )
    printf(1, "Total: %7d, Unique: %7d\n", {0,0})
    puts(1, "No words at all\n")
    puts(1, "No words of any length\n")
    printf(1, "Elapsed time: %f\n", time() - START)
    abort(0)

end if -- end of inpfile > 0

--output_token_list()

--seem to get correct number of words with file1.txt
--now the hashing!
--since I have no clue how to hash, this will almost be an exact copy of hash.ex
--I don't expect to be any where near the top, but testing - looks faster than brute sort
--used in cbwc-01 (hopefully should take less than the hour or so 01 took!)



--build the hash table (?)
--for i = 1 to length(token_list) do
--    hash_add(token_list[i])
--end for


--get most frequent words
----------------------------------------------------------------------------------------------------------------------------
procedure shift_MFT(integer posn)      
----------------------------------------------------------------------------------------------------------------------------
for i = displayXtokens-1 to posn by -1 do
    MFT[i+1] = MFT[i]
end for
end procedure
----------------------------------------------------------------------------------------------------------------------------
procedure compare_and_sort(sequence str, integer fr)      
----------------------------------------------------------------------------------------------------------------------------
sequence temp
if fr > MFT[displayXtokens][2] then     --don't even bother if its less than the last one on the list
    for i = 1 to displayXtokens do
        if fr > MFT[i][2] then
            if i < displayXtokens then
                shift_MFT(i)
                MFT[i] = {str,fr}
            elsif i = displayXtokens then
                MFT[displayXtokens] = {str,fr}
            end if
            exit
        end if
    end for
end if

end procedure
----------------------------------------------------------------------------------------------------------------------------

--get the number of unique tokens
items = 0
for i = 1 to length(hash_table) do
    items += length(hash_table[i])
end for

displayXtokens = floor( (items/1000) + 1 )
if displayXtokens > 20 then displayXtokens = 20 end if
MFT = repeat( {"",0}, displayXtokens)

--get the most frequent tokens
for i = 1 to length(hash_table) do
    for j = 1 to length(hash_table[i]) do
        compare_and_sort(hash_table[i][j][STRING], hash_table[i][j][COUNT]) 
    end for
end for


printf(1, "Chris Burch %s\n", {fname} )
printf(1, "Total: %7d, Unique: %7d\n", {total_words, items})

for i = 1 to displayXtokens do
	printf(1, "%02d %-20s %d\n" , {i,MFT[i][1],MFT[i][2]})
end for


for i = 1 to 20 do
	if FrequencyTable[i] > 0 then
		printf(1, "%02d %d\n", {i,FrequencyTable[i]})
	end if
end for

--v last line
printf(1, "Elapsed time: %f\n", time() - START)

